package schedframe.events.scheduling;

import schedframe.events.EventType;

public enum SchedulingEventType implements EventType {

	// task related
	TASK_FINISHED(1),
	TASK_FAILED(2),
	TASK_CANCELED(4),
	TASK_ARRIVED(8),
	TASK_PAUSED(16),
	TASK_RESUMED(32),
	TASK_MOVED(64),
	START_TASK_EXECUTION(128),
	TASK_REQUESTED_TIME_EXPIRED(256),

	//job related
	JOB_ARRIVED(512),
	JOB_FINISHED(1024),
	JOB_FAILED(2048),
	JOB_CANCELED(4096),

	//time related
	TIMER(8192),
	
	//reservation related
	RESERVATION_ACTIVE(16384),
	RESERVATION_FINISHED(32768),
	RESERVATION_FAILED(65536),
	RESERVATION_EXPIRED(131072),
	
	//resource related
	RESOURCE_FAILED(262144),
	//provider related (relevant to grid scheduling)
	PROVIDER_FAILED(524288),

	RESOURCE_STATE_CHANGED(1048576),
	
	POWER_LIMIT_EXCEEDED(2097152)
	;
	
	protected int tag;
	
	private SchedulingEventType(int tag){
		this.tag = tag;
	}
	
	public int getTag(){
		return this.tag;
	}
	
	public String getName(){
		return toString();
	}
}
